window.addEventListener('keyup', function(event) { Input.onKeyUp(event); }, false);
window.addEventListener('keydown', function(event) { Input.onKeyDown(event); }, false);

var Input = {
	_key_pressed: {},
	_key_can_pressed: {},
	_key_down: {},

	Update: function() {
		this._key_pressed = this._key_can_pressed;
		this._key_can_pressed = {};
	},

	isKeyDown: function(keyCode) {
		return this._key_down[keyCode];
	},
	
	isKeyPress: function(keyCode) {
		return this._key_pressed[keyCode];
	},
	  
	onKeyDown: function(event)
	{			
		this._key_down[event.keyCode] = true;
		console.log('KeyDown ' + event.keyCode);
	},
	  
	onKeyUp: function(event)
	{
		if (this.isKeyDown(event.keyCode))
			this._key_can_pressed[event.keyCode] = true;
		delete this._key_down[event.keyCode];	
		console.log('KeyUp ' + event.keyCode);
	}
};

var Keys = {
	A: 65,
	W: 87,
	D: 68,
	S: 83,
	Q: 81,
	E: 69,
	SPACE: 32
};
/*
var Key = {
	_pressed: {},
	_can_pressed: {},
	_down: {},

	A: 65,
	W: 87,
	D: 68,
	S: 83,
	SPACE: 32,
	  
	isDown: function(keyCode)
	{		
		return this._down[keyCode];
	},
	
	isPress: function(keyCode)
	{
		return this._pressed[keyCode];
	}
	  
	onKeydown: function(event)
	{			
		this._down[event.keyCode] = true;
	},
	  
	onKeyup: function(event)
	{		
		if (!isDown(event.keyCode))
			this._can_pressed[event.keyCode] = true;
		delete this._down[event.keyCode];	
	}
};
*/